///scr_dialogue(name,text,speed,instance,voice,skip);

txt = instance_create(0, 0, obj_text); // Création de notre instance qui va dessiner la bulle et le texte
with(txt) { // Dans l'instance que nous venons de créer

    padding = 16; // Espace entre la bulle et le texte (à l'intérieur de la bulle)
    h_name_padding = 25; // Espace horizontal entre l'encadré et le nom (à l'intérieur de l'encadré)
    v_name_padding = 3; // Espace vertical entre l'encadré et le nom (à l'intérieur de l'encadré)
    max_length = room_width/2; // Taille maximale de la bulle (ici limité à la moitié de la salle)
    name = argument0; // Nom du personnage qui parle
    text = argument1; // Texte à écrire
    spd = argument2; // Vitesse d'écriture
    skip_allowed = argument5; // Possibilité de passer le texte rapidement avec espace
    
    // Choix de la voix
    switch(argument4) {
        case 0 : play_voice = false; break;
        case 1 : voice = snd_voice_woman; play_voice = true; break; // Bon au final, j'utilise celle-ci pour la voix du drone
        case 2 : voice = snd_voice_woman_2; play_voice = true; break;
        case 3 : voice = snd_voice_woman_3; play_voice = true; break; // Ressemble plus à un bruit de souris en fait...
        case 4 : voice = snd_voice_woman_4; play_voice = true; break; // Définitivement la meilleure pour la voix de l'assistante
        default : play_voice = false; break;
    }
    
    font = fnt_courier_new; // Police d'écriture du texte
    font_nm = fnt_courier_new_b; // Police d'écriture du nom
    
    name_color = c_white; // Couleur d'affichage du nom
    text_color = c_white; // Couleur d'affichage du texte
    box_color = make_color_rgb(45,45,45); // Couleur de fond de la bulle
    name_box_color = c_dkgray; // Couleur de fond de l'encadré du nom
    
    speaking_instance = argument3;
    x_instance = speaking_instance.x; // Position x de l'instance qui parle
    y_instance = speaking_instance.y; // Position y de l'instance qui parle
    
    // Définition des dimensions pour le nom
    draw_set_font(font_nm);
    font_size_nm = font_get_size(font_nm);
    
    name_width = string_width_ext(name, 0, max_length);
    name_height = string_height_ext(name, 0, max_length);
    name_box_width = name_width + (h_name_padding*2); // Largeur de l'encadré du nom
    name_box_height = name_height + (v_name_padding*2); // Hauteur de l'encadré du nom
    
    
    // Définition des dimensions pour le texte
    draw_set_font(font);
    text_length = string_length(text); // Taille du texte à écrire en nombre de caractères
    font_size = font_get_size(font); // Taille de la police utilisée
    
    text_width = string_width_ext(text,font_size+(font_size/2), max_length); // Largeur du texte
    text_height = string_height_ext(text,font_size+(font_size/2), max_length); // Hauteur du texte
    box_width = text_width + (padding*2); // Largeur de la bulle
    box_height = text_height + (padding*2); // Hauteur de la bulle
    
    // On s'assure que la bulle soit toujours plus large que l'encadré du nom
    if(box_width < (name_box_width + (padding *2))) {
        box_width = name_box_width + (padding *2);
    }
    
    // Position initiale de la bulle
    x_instance = speaking_instance.x + (sprite_get_width(speaking_instance.sprite_index)/2); // Position x du milieu de l'instance qui parle (l'endroit où se trouve la tête normalement)
    y_instance = speaking_instance.y; // Position y de l'instance qui parle
    x = x_instance - (box_width/2);
    y = y_instance - (box_height + 18);
    
    // Limitation horizontale de la bulle pour qu'elle ne sorte pas de la fenêtre
    if(x < 10) {
        x = 10;
    } else if((x + box_width) > room_width - 10) {
        x = room_width - box_width - 10;
    }
    
    // Limitation horizontale de l'appendice
    if (x_instance < 15) {
        x_instance = 15;
    } else if (x_instance > room_width - 15) {
        x_instance = room_width - 15;
    }
}
